<?php
/*------------------------------------------------------------------------
# BIT Linked Checkboxes
# ------------------------------------------------------------------------
# author:    Barg-IT
# copyright: Copyright (C) 2018 Barg-IT
# @license:  http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Website:   http://www.barg-it.de
-------------------------------------------------------------------------*/

defined('_JEXEC') or die;

jimport('joomla.form.helper');
JFormHelper::loadFieldClass('checkboxes');

class JFormFieldBitlinkedcheckboxes extends JFormFieldCheckBoxes
{
    protected $type = 'Bitlinkedcheckboxes';

    public function getInput()
    { 
        $el = $this->element;  
        $attrs = $el->attributes(); 
        $plg_name = (string) $attrs->name; 
		$required = (string)$attrs->required; 
        $id = 'jform_com_fields_' . $plg_name;
        $moreOptions = $this->getMoreOptions($plg_name); 
        $moreParams = json_decode($moreOptions->fieldparams); 
              
        $arr_options = (array) $moreParams->options;
        $keys = array_keys($arr_options); // Die Array-Keys ändern sich mit der Anzahl der vorhandenen Custom-Fields im Formular
        $len=count($keys);
        $box_html='';
        for($nr = 0; $nr< $len; $nr++){

            $current_option = $arr_options[$keys[$nr]]; 
            $opt_name = $current_option->name;
            $opt_value = $current_option->value;
            if(isset ($current_option->link)) {$opt_link = $current_option->link;} else {$opt_link = '';}
            if(isset ($current_option->linktext) && $current_option->linktext !== '') {$opt_linktext = $current_option->linktext;} else {$opt_linktext = JText::_('PLG_FIELDS_CHECKLINK_MORE');}

			$ds_link = '';
			if($opt_link !== '') {
				$link = JRoute::_("index.php?Itemid={$opt_link}");
				$ds_link = '<a href="' . $link . '" class="bit_chk_lnk" target="_blank">' . $opt_linktext . '</a>';
			    if (strpos($opt_name, $opt_linktext) > -1 ) {
				   $text = str_replace($opt_linktext, $ds_link, $opt_name);
				}else{
					$text=$opt_name . ' ' . $ds_link;
				}
			
 			}	
			else $text = $opt_name;
            
            $box_html .= <<<BOXHTML
            
            <label for="jform_com_fields_$plg_name$nr" class="checkbox">
            <input id="jform_com_fields_$plg_name$nr" name="jform[com_fields][$plg_name][]" value="$opt_value" type="checkbox">
            $text
            </label>
            
BOXHTML;

        }
		if($required == 'true') {
			$erg_html='<fieldset id="'.$id.'" class="required checkboxes" required="" aria-required="true">'.$box_html.'</fieldset>';
		} else {
			$erg_html='<fieldset id="'.$id.'" class="checkboxes">'.$box_html.'</fieldset>';
		};
		
        return $erg_html;
    }

    public function getMoreOptions($name)
    {
        $search_type = lcfirst($this->type); 
		$app = JFactory::getApplication();
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $query->select('*')->from('`#__fields` AS a')->where('a.type = "' . $search_type . '" ')->where('a.name = "' . $name . '" ')->where('a.state =' .$db->quote(1));  
        $rows = $db->setQuery($query)->loadObjectlist();
        $options = $rows[0]; 
        return $options;
    }

}
